#!C:\Perl\bin\perl.exe -w
#
#	      This script expects the requesting page with
#	      input field name, ufile.
#

use strict;
use vars qw($cgi $fu $sizewritten);

# Autoflush.
$| = 1;

# Print the HTTP header line.
# I am not using CGI->header here because I want to check if CGI
# version 2.46 or above is installed.
print "Content-Type: text/html\n\n";

# Make sure CGI version 2.46 or above is installed.
eval("use CGI 2.46 qw(-private_tempfiles :standard);");
(print("Error: $@"), exit(-1)) if $@;

# Make sure FileUpload is installed.
eval("use FileUpload;");
(print("Error: $@"), exit(-1)) if $@;

# Create CGI object.
$cgi = new CGI;

# Have any files been selected for upload?
if (! $cgi->param('ufile')) {
  print <<__END__ERROR__;
<html>
<head><title>Failed to save file</title></head>
<body bgcolor='white'>
It appears you have not selected a files to upload.
Please try again.
</body>
</html>
__END__ERROR__
  exit(-1);
}

# Create the FileUpload object.
$fu = new FileUpload($cgi->param('ufile'));

# Print results.
print <<__END__HTML__;
<html>
<head><title>
__END__HTML__
# Try to save the uploaded file.
$sizewritten = -1;
if (!($sizewritten = $fu->save_as(${\$fu->orig_filename}))) {
  print "Failed to save file: $!";
}
else {
  print $sizewritten." bytes written";
}
print <<__END__HTML1__;
</title>
</head>
<body bgcolor='white'>
<h2>Upload Result</h2>
<hr>
<blockquote>
<table border='1' width='80%' cellpadding='5'>
<tr>
  <th>Action</th>
  <th>Command</th>
  <th>Returns</th>
</tr>
<tr>
  <td align='left'>Original filename</td>
  <td><font face='Courier'>\$fu-&gt;orig_filename</font></td>
  <td><font face='Courier'>${\$fu->orig_filename}</font></td>
</tr>
<tr>
  <td align='left'>Original filepath</td>
  <td><font face='Courier'>\$fu-&gt;orig_filepath</font></td>
  <td><font face='Courier'>${\$fu->orig_filepath}</font></td>
</tr>
<tr>
  <td align='left'>Add extensions denied</td>
  <td><font face='Courier'>\$fu-&gt;deny_ext('cgi', 'shtml')</font></td>
  <td><font face='Courier'><font color='blue'>${\sprintf("%s", join("</font>,<font color='blue'>", $fu->deny_ext('cgi', 'shtml')))}</font></font></td>
</tr>
<tr>
  <td align='left'>Extensions denied</td>
  <td><font face='Courier'>\$fu-&gt;deny_ext</font></td>
  <td><font face='Courier'><font color='blue'>${\sprintf("%s", join("</font>,<font color='blue'>", $fu->deny_ext))}</font></font></td>
</tr>
<tr>
  <td align='left'>Characters allowed</td>
  <td><font face='Courier'>\$fu-&gt;allow_char</font></td>
  <td><font face='Courier'><font color='blue'>${\sprintf("%s", join("</font>,<font color='blue'>", $fu->allow_char))}</font></font></td>
</tr>
__END__HTML1__
print <<__END__HTML2__;
  <tr>
  <td align='left'>Add characters allowed</td>
  <td><font face='Courier'>\$fu-&gt;allow_char('#\/', '\,')</font></td>
  <td><font face='Courier'><font color='blue'>${\sprintf("%s", join("</font>,<font color='blue'>", $fu->allow_char('#\/', '\,')))}</font></font></td>
</tr>
<tr>
  <td align='left'>Characters allowed</td>
  <td><font face='Courier'>\$fu-&gt;allow_char</font></td>
  <td><font face='Courier'><font color='blue'>${\sprintf("%s", join("</font>,<font color='blue'>", $fu->allow_char))}</font></font></td>
</tr>
<tr>
  <td align='left'>Current FILEHANDLE position</td>
  <td><font face='Courier'>\$fu-&gt;get_pos</font></td>
  <td><font face='Courier'>${\$fu->get_pos}</font></td>
</tr>
<tr>
  <td align='left'>Set FILEHANDLE position</td>
  <td><font face='Courier'>\$fu-&gt;set_pos(255)</font></td>
  <td><font face='Courier'>${\$fu->set_pos(255)}</font></td>
</tr>
<tr>
  <td align='left'>Current FILEHANDLE position</td>
  <td><font face='Courier'>\$fu-&gt;get_pos</font></td>
  <td><font face='Courier'>${\$fu->get_pos}</font></td>
</tr>
<tr>
  <td align='left'>File size</td>
  <td><font face='Courier'>\$fu-&gt;size</font></td>
  <td><font face='Courier'>${\$fu->size}</font></td>
</tr>
__END__HTML2__
print <<__END__HTML3__;
</table>
</blockquote>
</body>
</html>
__END__HTML3__

# Done.
exit(0);
__END__


